#include "ips_audio_alsa_ALSAMixerProvider.h"

JNIEXPORT void JNICALL Java_ips_audio_alsa_ALSAMixerProvider_enumerateCards(JNIEnv *env, jobject obj) {
	int ind=-1;
	int *indp=&ind;
	int res=0;
	char name[100];
	char *np=name;
	jclass class=(*env)->FindClass(env,"ips/audio/alsa/ALSAMixerProvider");
	if(class==NULL){
		fprintf(stderr,"Java Class not found!");
		return;
	}
	jmethodID mId=(*env)->GetMethodID(env,class,"nextCard","(ILjava/lang/String;)V");
	if(mId==NULL){
		fprintf(stderr,"Method not found!");
		return;
	}
	do{
		int res=snd_card_next(indp);
		if(res==0 && *indp!=-1){
			snd_card_get_name((int)(*indp),&np);
			//printf("Card: %d: %s\n",*indp,np);
			jstring name=(*env)->NewStringUTF(env,np);
			(*env)->CallVoidMethod(env,obj,mId,(jint)(*indp),name);
		}
	}while(res==0 && *indp!=-1);

	return;
}

JNIEXPORT void JNICALL Java_ips_audio_alsa_ALSAMixerProvider_enumerateDevices(JNIEnv *env, jobject obj,jstring cardId) {


	int res=0;


	snd_ctl_t *handle;
	//snd_ctl_card_info_t *info;
	//snd_pcm_info_t *pcminfo;
	//snd_ctl_card_info_alloca(&info);
	//snd_pcm_info_alloca(&pcminfo);

	jboolean iscopy;
	jclass class=(*env)->FindClass(env,"ips/audio/alsa/ALSAMixerProvider");
	if(class==NULL){
		fprintf(stderr,"Java Class not found!");
		return;
	}
	jmethodID mId=(*env)->GetMethodID(env,class,"nextDevice","(I)V");
	if(mId==NULL){
		fprintf(stderr,"Method not found!");
		return;
	}
	const char *aname = (*env)->GetStringUTFChars(env,cardId, &iscopy);
	//printf("%s\n",aname);
	snd_ctl_open(&handle, aname, 0);
	//snd_ctl_card_info(handle, info);
	int dev=-1;
	do{
		res=snd_ctl_pcm_next_device(handle, &dev);
		if(res==0 && dev != -1){
			(*env)->CallVoidMethod(env,obj,mId,dev);
		}
	}while(res==0 && dev!=-1);
	snd_ctl_close(handle);

	return;
}
/*
JNIEXPORT void JNICALL Java_ips_audio_alsa_ALSAMixerProvider_enumeratePCMHints(JNIEnv *env, jobject obj) {

	//int res=0;
	void **hints;
	//res=snd_device_name_hint(-1,"pcm",&hints);
	//void **str;
	char *name;
	char *desc;
	//char *io;
	//str = hints;
	 char *desc_tmp;
	while (*str) {
	      name = snd_device_name_get_hint(*str, "NAME");
	      desc = snd_device_name_get_hint(*str, "DESC");
	  //    io = snd_device_name_get_hint(*str, "IOID");

	      //printf("\n-- %s --\n", name);
	      //printf("IO: %s\n", io);

	      desc_tmp = strtok(desc, "\n");

	      while (desc_tmp != NULL) {
	          //printf("%s\n", desc_tmp);
	          desc_tmp = strtok(NULL, "\n");
	      }

	      free(name);
	      free(desc);
	      str++;
	    }
	    snd_device_name_free_hint(hints);
	return;
}
*/



JNIEXPORT void JNICALL Java_ips_audio_alsa_ALSAMixerProvider_enumeratePCMConfig(JNIEnv *env, jobject obj) {


	int res=0;
	snd_config_t *node = NULL;

	snd_config_update();
	if(snd_config){
		snd_config_search(snd_config,"pcm",&node);
		snd_config_iterator_t i, in;

		snd_config_for_each( i, in, node ){
			const char *tpStr = "unknown", *idStr = NULL;
	//		int err = 0;

		//	char *alsaDeviceName, *deviceName;
			//const HwDevInfo *predefined = NULL;
			snd_config_t *n = snd_config_iterator_entry( i ), * tp = NULL;;

			if( (res = snd_config_search( n, "type", &tp )) < 0 ){

			}else{
				res=snd_config_get_string( tp, &tpStr );
			}
			res=snd_config_get_id( n, &idStr );

			//printf("Found plugin %s of type %s\n",idStr, tpStr );

			jclass class=(*env)->FindClass(env,"ips/audio/alsa/ALSAMixerProvider");
			if(class==NULL){
				fprintf(stderr,"Java Class not found!");
				return;
			}
			jmethodID mId=(*env)->GetMethodID(env,class,"nextPluginDevice","(Ljava/lang/String;Ljava/lang/String;)V");
			if(mId==NULL){
				fprintf(stderr,"Method not found!");
				return;
			}
			jstring type=(*env)->NewStringUTF(env,tpStr);
			jstring name=(*env)->NewStringUTF(env,idStr);
			(*env)->CallVoidMethod(env,obj,mId,type,name);
		}

	}
	return;
}

JNIEXPORT void JNICALL Java_ips_audio_alsa_ALSAMixerProvider_test(JNIEnv *env, jobject obj) {
	int ind=-1;
	int *indp=&ind;
	int res=0;
	char name[100];
	char *np=name;
	snd_ctl_t *handle;
	snd_ctl_card_info_t *info;
	snd_pcm_info_t *pcminfo;
	snd_ctl_card_info_alloca(&info);
	snd_pcm_info_alloca(&pcminfo);

	do{
		int res=snd_card_next(indp);
		if(res==0 && *indp!=-1){
			snd_card_get_name((int)(*indp),&np);
			//printf("Card: %d: %s\n",*indp,np);
			char aname[32];
			sprintf(aname, "hw:%d", *indp);
			snd_ctl_open(&handle, aname, 0);
			snd_ctl_card_info(handle, info);

			int dev=-1;
			do{
				res=snd_ctl_pcm_next_device(handle, &dev);
				if(res==0 && dev != -1){
					//printf("PCM device: %d\n",dev);
				}
			}while(res==0 && dev!=-1);
			snd_ctl_close(handle);
			void ** hints;
			res=snd_device_name_hint(0,"pcm",&hints);
			void *hint=NULL;
			int i=0;
			do{

				hint=hints[i];
				/*
				if(hint!=NULL){
					char* hname=snd_device_name_get_hint(hint,"NAME");
					//printf("Name: %s\n",hname);
				}
				*/
				i++;
			}while(hint!=NULL);

		}
	}while(res==0 && *indp!=-1);

	return;
}

JNIEXPORT void JNICALL Java_ips_audio_alsa_ALSAMixerProvider_release(JNIEnv *env, jobject obj){
}

int main(int argc,char *argv[]){
	Java_ips_audio_alsa_ALSAMixerProvider_test(NULL,NULL);
	return 0;
}

