#include "ips_audio_alsa_ALSASourceDataLine.h"
#include "ips_audio_alsa_ALSAMixer.h"
#include "ips_audio_alsa_ALSADataLine.h"

//JNIEXPORT void JNICALL Java_ips_audio_alsa_ALSATargetDataLine_open(JNIEnv *env, jobject obj,jint cardNumber,jint devNumber,jstring type,jint channels,jint samplerate,jint frameSize,jint bits,jboolean s,jboolean bigEndian){
//
//
//	//const char *msg_t=&msg;
//	//jsize typeLen=(*env)->GetStringLength(env,type);
//	jboolean iscopy;
//	const char *devTypeC= (*env)->GetStringUTFChars(env,type, &iscopy);
//	// Estimate device name length. Uhhhh. Dirty.
//	//int maxDevLen=typeLen+1+100+1+100;
//	//char *devName=(char*)calloc(maxDevLen,sizeof(char));
//	char devName[MAX_MSG_LEN];
//	snprintf(devName,MAX_MSG_LEN,"%s:%d,%d",devTypeC,cardNumber,devNumber);
//	dataline_t* dl=getDataline(env,obj);
//	openPCMDevice(env,obj,dl,devName,channels,samplerate,frameSize,bits,s,bigEndian);
//}

JNIEXPORT void JNICALL Java_ips_audio_alsa_ALSASourceDataLine_open(JNIEnv *env, jobject obj,jstring devNameJ,jint hardwareChannels,jint channels,jint samplerate,jint frameSize,jint bits,jboolean s,jboolean bigEndian,jboolean blockingMode,jint bufferSize){

	jboolean iscopy;
	const char *devName= (*env)->GetStringUTFChars(env,devNameJ, &iscopy);
	dataline_t* dl=getDataline(env,obj);
	if(DEBUG>0)printf("Open PCM Device %s\n",devName);
	char msg[MAX_MSG_LEN];
	//dataline_t* dl=&datalines[cardNumber][devNumber][0];


	dl->framesTransfered=0;
	dl->frameSize=frameSize;
	dl->channels=channels;
	int sampleSize=frameSize/channels;


	snd_pcm_format_t format=snd_pcm_build_linear_format(sampleSize*8,bits,!s,bigEndian);
	if(format==SND_PCM_FORMAT_UNKNOWN){
		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),"Unknown audio format");
		return;
	}
	unsigned int pbChannels=channels;

	unsigned int pbFrameSize=frameSize;

		if(hardwareChannels>0){
			if(channels>hardwareChannels){
					snprintf (msg,MAX_MSG_LEN, "Requested channel count (%d) is greater then available hardware channels (%d)\n",channels,hardwareChannels);
					(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),msg);
					return;
			}
			pbChannels=hardwareChannels;
			pbFrameSize=frameSize*hardwareChannels/channels;
		}

		int preferredBufferSizeFrames=-1;
			int prefBufferSize=bufferSize;
			if(prefBufferSize>0){
				preferredBufferSizeFrames=((prefBufferSize *pbChannels)/channels)/pbFrameSize;
			}
	int mode=0;
	if(!blockingMode){
		mode=SND_PCM_NONBLOCK;
		if(DEBUG > 2)printf ("NONBLOCK mode open\n");
	}
	int ret=snd_pcm_open(&(dl->pcm),devName,SND_PCM_STREAM_PLAYBACK,mode);

	if(ret<0){
		snprintf (msg,MAX_MSG_LEN, "Cannot open playback audio line %s (%s)\n",devName,snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"javax/sound/sampled/LineUnavailableException"),(const char*)&msg);
		return;
	}
	if(DEBUG>0)printf("PCM Device %s opened.\n",devName);


	if ((ret = snd_pcm_hw_params_malloc (&dl->hw_params)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot allocate hardware parameter structure (%s)\n",snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"javax/sound/sampled/LineUnavailableException"),(const char*)&msg);
		return;

	}

	if ((ret = snd_pcm_hw_params_any (dl->pcm, dl->hw_params)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot initialize hardware parameter structure (%s)\n",snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"javax/sound/sampled/LineUnavailableException"),(const char*)&msg);
		return;
	}

	if ((ret = snd_pcm_hw_params_set_access (dl->pcm, dl->hw_params, SND_PCM_ACCESS_RW_INTERLEAVED)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot set R/W interleaved access type (%s)\n",snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),(const char*)&msg);
		ajsCloseDataLine(dl);
		return;
	}

	if ((ret = snd_pcm_hw_params_set_format (dl->pcm, dl->hw_params, format))< 0) {
		snprintf (msg,MAX_MSG_LEN, "Invalid sample format (%s)\n",snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),(const char*)&msg);
		ajsCloseDataLine(dl);
		return;

	}
	if ((ret = snd_pcm_hw_params_set_rate(dl->pcm, dl->hw_params, samplerate, 0)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot set sample rate %d (%s)\n",samplerate,snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),(const char*)&msg);
		ajsCloseDataLine(dl);
		return;
	}

	if ((ret = snd_pcm_hw_params_set_channels (dl->pcm, dl->hw_params, pbChannels)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot set set channel count to %d (%s)\n",pbChannels,snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),(const char*)&msg);
		ajsCloseDataLine(dl);
		return;
	}

	if ((ret = snd_pcm_hw_params (dl->pcm, dl->hw_params)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot set parameters (%s)\n",snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/lang/IllegalArgumentException"),(const char*)&msg);
		ajsCloseDataLine(dl);
		return;
	}
	snd_pcm_uframes_t bs;
	ret =snd_pcm_hw_params_get_buffer_size(dl->hw_params,&bs);
	snd_pcm_uframes_t bsMin;
	snd_pcm_hw_params_get_buffer_size_min(dl->hw_params,&bsMin);
	snd_pcm_uframes_t bsMax;
	snd_pcm_hw_params_get_buffer_size_max(dl->hw_params,&bsMax);
	if(DEBUG>2)printf("Buffer size frames min: %lu max: %lu  normal: %lu\n",bsMin,bsMax,bs);

	//unsigned long prefBufferSizeFrames = 8 * 4 * 44100;

	//unsigned long maxBufferSizeFrames=prefBufferSizeFrames;
	//unsigned long minBufferSizeFrames=prefBufferSizeFrames;
	unsigned long bufferSizeFrames=preferredBufferSizeFrames;
	/*
	snd_pcm_hw_params_set_buffer_size_min(dl->pcm,dl->hw_params,&minBufferSizeFrames);
	snd_pcm_hw_params_set_buffer_size_max(dl->pcm,dl->hw_params,&maxBufferSizeFrames);
	snd_pcm_hw_params_get_buffer_size(dl->hw_params,&bufferSizeFrames);
	printf("Buffer size frames pref max: %ld max set: %ld\n",prefBufferSizeFrames,maxBufferSizeFrames);
	printf("Buffer size frames pref min: %ld min set: %ld\n",prefBufferSizeFrames,minBufferSizeFrames);
	 */
	if(preferredBufferSizeFrames>0){
	if(DEBUG>2)printf("Try to set buffer size frames: %d\n",preferredBufferSizeFrames);
	ret=snd_pcm_hw_params_set_buffer_size_near(dl->pcm,dl->hw_params,&bufferSizeFrames);
	}
	if(DEBUG>2)printf("%d, %s: Buffer size frames set: %lu\n",ret,snd_strerror (ret),bufferSizeFrames);
	if(DEBUG>0)fflush(stdout);


	if ((ret = snd_pcm_prepare (dl->pcm)) < 0) {
		snprintf (msg,MAX_MSG_LEN, "Cannot prepare playback audio line %s (%s)\n",devName,snd_strerror (ret));
		(*env)->ThrowNew(env,(*env)->FindClass(env,"javax/sound/sampled/LineUnavailableException"),(const char*)&msg);
		ajsCloseDataLine(dl);
		return;
	}
}

JNIEXPORT jint JNICALL Java_ips_audio_alsa_ALSASourceDataLine_nWrite(JNIEnv* env, jobject obj,jbyteArray buf,jint offset,jint len){

	//jint read=0;

	dataline_t* dl=getDataline(env,obj);
	unsigned int pbChannels;
	int ret=snd_pcm_hw_params_get_channels(dl->hw_params,&pbChannels);
	//unsigned int channels=dl->channels;
	if(ret<0){

		(*env)->ThrowNew(env,(*env)->FindClass(env,"java/io/IOException"),(const char*)"Cannot get channel count.");
		return 0;
	}
	//int pbLen=len*pbChannels/channels;

	//const void *nBuf;
	int lenPbFrames=len/dl->frameSize;

	snd_pcm_sframes_t written=snd_pcm_writei(dl->pcm,buf,lenPbFrames);
	return written;
}



